'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var PropTypes = _interopDefault(require('prop-types'));
var reactWindow = require('react-window');
var AutoSizer = _interopDefault(require('react-virtualized-auto-sizer'));
var InfiniteLoader = _interopDefault(require('react-window-infinite-loader'));

InfiniteLoading.propTypes = {
  hasMoreItems: PropTypes.bool,
  loadMoreItems: PropTypes.func,
  children: PropTypes.array.isRequired,
  itemHeight: PropTypes.number.isRequired,
  placeholder: PropTypes.node
};

InfiniteLoading.defaultProps = {
  hasMoreItems: false,
  loadMoreItems: function loadMoreItems() {}
};

function InfiniteLoading(_ref, ref) {
  var children = _ref.children,
      hasMoreItems = _ref.hasMoreItems,
      itemHeight = _ref.itemHeight,
      loadMoreItems = _ref.loadMoreItems,
      placeholder = _ref.placeholder;

  var itemsCount = hasMoreItems ? children.length + 1 : children.length;
  var isItemLoaded = function isItemLoaded(index) {
    return !hasMoreItems || index < children.length;
  };

  return React__default.createElement(
    AutoSizer,
    null,
    function (_ref2) {
      var height = _ref2.height,
          width = _ref2.width;
      return React__default.createElement(
        InfiniteLoader,
        {
          isItemLoaded: isItemLoaded,
          itemCount: itemsCount,
          loadMoreItems: loadMoreItems,
          ref: ref
        },
        function (_ref3) {
          var onItemsRendered = _ref3.onItemsRendered,
              ref = _ref3.ref;
          return React__default.createElement(
            reactWindow.FixedSizeList,
            {
              height: height,
              itemCount: itemsCount,
              itemSize: itemHeight,
              onItemsRendered: onItemsRendered,
              ref: ref,
              width: width
            },
            function (_ref4) {
              var index = _ref4.index,
                  style = _ref4.style;
              return React__default.createElement(
                'div',
                { style: style },
                children[index] != null ? children[index] : placeholder
              );
            }
          );
        }
      );
    }
  );
}

var index = React.forwardRef(InfiniteLoading);

module.exports = index;
//# sourceMappingURL=index.js.map
